package inf43.spring2009.console;

import java.util.Scanner;


public class Console
{
	private static Scanner consoleIn;
	private static int outputLinesSinceInput;
	private static int LINES_PER_BREAK = 20;
	private static String LINE_SEPARATOR = System.getProperty("line.separator");
	
	
	static
	{
		consoleIn = new Scanner(System.in);
		clearBreakCounter();
	}
	
	
	public static String getLineSeparator()
	{
		return LINE_SEPARATOR;
	}
	
	
	public static String readLine()
	{
		clearBreakCounter();
		return consoleIn.nextLine();
	}
	
	
	public static void write(String text)
	{
		System.out.print(text);
	}
	
	
	public static void writeLine()
	{
		writeLine("");
	}
	
	
	public static void writeLine(String text)
	{
		System.out.println(text);
		checkForBreak();
	}
	
	
	private static void clearBreakCounter()
	{
		outputLinesSinceInput = 0;
	}
	
	
	private static void checkForBreak()
	{
		outputLinesSinceInput++;
		
		if (outputLinesSinceInput % LINES_PER_BREAK == 0)
		{
			System.out.print("[PRESS Enter FOR MORE]");
			readLine();
		}
	}
}
