package inf43.spring2009.console.displays;

import java.util.ArrayList;
import java.util.List;


public class DetailsDisplay<ElementType>
{
	private ArrayList<DetailsFieldDisplay<ElementType>> fieldDisplays;
	
	
	public DetailsDisplay(List<DetailsFieldDisplay<ElementType>> fieldDisplays)
	{
		this.fieldDisplays = new ArrayList<DetailsFieldDisplay<ElementType>>(fieldDisplays);
	}


	public void show(ElementType element)
	{
		int fieldNameWidth = getMaxFieldNameLength();
		
		for (DetailsFieldDisplay<ElementType> fieldDisplay : fieldDisplays)
		{
			fieldDisplay.show(fieldNameWidth, element);
		}
	}
	
	
	private int getMaxFieldNameLength()
	{
		int maxFieldNameLength = 0;
		
		for (DetailsFieldDisplay<ElementType> fieldDisplay : fieldDisplays)
		{
			int fieldNameLength = fieldDisplay.getFieldName().length();
			
			if (fieldNameLength > maxFieldNameLength)
			{
				maxFieldNameLength = fieldNameLength;
			}
		}
		
		return maxFieldNameLength;
	}
}
