package inf43.spring2009.console.displays;

import inf43.spring2009.console.Console;


public abstract class DetailsFieldDisplay<ElementType>
{
	private String fieldName;
	
	
	public DetailsFieldDisplay(String fieldName)
	{
		this.fieldName = fieldName;
	}
	
	
	public String getFieldName()
	{
		return fieldName;
	}
	
	
	public void show(int fieldNameWidth, ElementType element)
	{
		String fullDisplayString = toDisplayString(element);
		
		String[] displayLines = fullDisplayString.split(Console.getLineSeparator());

		if (displayLines.length == 0)
		{
			Console.writeLine(
				String.format(
					"%-" + fieldNameWidth + "s:",
					fieldName));
		}
		else
		{
			Console.writeLine(
				String.format(
					"%-" + fieldNameWidth + "s: %s",
					fieldName,
					displayLines[0]));
			
			for (int i = 1; i < displayLines.length; i++)
			{
				Console.writeLine(
					String.format(
						"%-" + (fieldNameWidth + 2) + "s%s",
						"",
						displayLines[i]));
			}
		}
	}
	
	
	protected abstract String toDisplayString(ElementType elementName);
}
