package inf43.spring2009.console.displays;

import inf43.spring2009.console.Console;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;


public class ListDisplay<ElementType>
{
	public void show(
		String title, String emptyListMessage,
		Iterable<ElementType> elements,
		Comparator<ElementType> sortComparator,
		ListElementDisplay<ElementType> elementDisplay)
	{
		List<ElementType> displayElements = new ArrayList<ElementType>();
		
		for (ElementType element : elements)
		{
			displayElements.add(element);
		}
		
		if (displayElements.size() == 0)
		{
			Console.writeLine(emptyListMessage);
		}
		else
		{
			Console.writeLine(title);
			
			if (sortComparator != null)
			{
				Collections.sort(displayElements, sortComparator);
			}
			
			for (ElementType displayElement : displayElements)
			{
				elementDisplay.show(displayElement);
			}
		}
	}
}
