package inf43.spring2009.console.displays;

import inf43.spring2009.console.Console;


public abstract class TableColumnDisplay<RowType>
{
	private String columnTitle;
	private int columnWidth;
	
	
	public TableColumnDisplay(String columnTitle, int columnWidth)
	{
		this.columnTitle = columnTitle;
		this.columnWidth = Math.max(columnWidth, columnTitle.length());
	}

	
	public void showColumnTitle()
	{
		showColumnValue(columnTitle);
	}
	
	
	public void showColumn(RowType row)
	{
		showColumnValue(toDisplayString(row));
	}
	
	
	private void showColumnValue(String displayString)
	{
		if (displayString.length() > columnWidth)
		{
			displayString = displayString.substring(0, columnWidth - 3) + "...";
		}
		
		Console.write(String.format("%-" + columnWidth + "s ", displayString));
	}
	
	
	protected abstract String toDisplayString(RowType row);
}
