package inf43.spring2009.console.displays;

import inf43.spring2009.console.Console;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;


public class TableDisplay<RowType>
{
	public void show(
		String title, String emptyTableMessage,
		Iterable<RowType> rows,
		Comparator<RowType> sortComparator,
		List<TableColumnDisplay<RowType>> columnDisplays)
	{
		List<RowType> displayRows = new ArrayList<RowType>();
		
		for (RowType row : rows)
		{
			displayRows.add(row);
		}
		
		if (displayRows.size() == 0)
		{
			Console.writeLine(emptyTableMessage);
		}
		else
		{
			Console.writeLine(title);
			
			if (sortComparator != null)
			{
				Collections.sort(displayRows, sortComparator);
			}
			
			for (TableColumnDisplay<RowType> columnDisplay : columnDisplays)
			{
				columnDisplay.showColumnTitle();
			}
			
			Console.writeLine();
			
			for (RowType displayRow : displayRows)
			{
				for (TableColumnDisplay<RowType> columnDisplay : columnDisplays)
				{
					columnDisplay.showColumn(displayRow);
				}

				Console.writeLine();
			}
		}
	}
}
