package inf43.spring2009.console.validators;


public abstract class ValidatorBase<ResultType> implements Validator<ResultType>
{
	private String errorMessage;
	
	
	public ValidatorBase(String errorMessage)
	{
		this.errorMessage = errorMessage;
	}
	
	
	public void validate(ResultType result)
	{
		if (!isValid(result))
		{
			throwValidationError();
		}
	}
	
	
	protected abstract boolean isValid(ResultType result);


	private void throwValidationError()
	{
		throw new ValidationException(errorMessage);
	}
}
