package inf43.spring2009.tpes.commands;

import inf43.spring2009.console.Console;
import inf43.spring2009.console.Prompt;
import inf43.spring2009.console.converters.ToYesNoConverter;
import inf43.spring2009.console.menus.CommandFailedException;
import inf43.spring2009.console.menus.CommandHandler;
import inf43.spring2009.console.menus.CommandHandlerResult;
import inf43.spring2009.tpes.model.TpesData;


public class FinishSemesterCommandHandler implements CommandHandler<TpesData>
{
	public CommandHandlerResult run(TpesData model)
	throws CommandFailedException
	{
		Console.writeLine("Finishing the current semester will destroy all courses, scheduled");
		Console.writeLine("course meetings, and student enrollment information.");
		Console.writeLine();
		
		boolean confirmed = Prompt.read(
			"Are you sure you'd like to finish the current semester?",
			"Enter Y (YES) or N (NO)",
			new ToYesNoConverter());
		
		if (confirmed)
		{
			model.finishSemester();
		}
		
		return CommandHandlerResult.ACCEPT_ANOTHER_COMMAND;
	}
}
