package inf43.spring2009.tpes.commands;

import inf43.spring2009.console.displays.TableColumnDisplay;
import inf43.spring2009.console.displays.TableDisplay;
import inf43.spring2009.console.menus.CommandFailedException;
import inf43.spring2009.console.menus.CommandHandler;
import inf43.spring2009.console.menus.CommandHandlerResult;
import inf43.spring2009.tpes.comparators.ClassroomsByNameComparator;
import inf43.spring2009.tpes.model.Classroom;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;
import java.util.List;


public class ListClassroomsCommandHandler implements CommandHandler<TpesData>
{
	public CommandHandlerResult run(TpesData model)
	throws CommandFailedException
	{
		new TableDisplay<Classroom>().show(
			"Classrooms", "There are no classrooms",
			model.getClassrooms(),
			new ClassroomsByNameComparator(),
			createTableColumnDisplays());

		return CommandHandlerResult.ACCEPT_ANOTHER_COMMAND;
	}
	
	
	private List<TableColumnDisplay<Classroom>> createTableColumnDisplays()
	{
		ArrayList<TableColumnDisplay<Classroom>> displays =
			new ArrayList<TableColumnDisplay<Classroom>>();
		
		displays.add(
			new TableColumnDisplay<Classroom>("Name", 30)
			{
				protected String toDisplayString(Classroom classroom)
				{
					return classroom.getName();
				}
			});
		
		displays.add(
			new TableColumnDisplay<Classroom>("Capacity", 8)
			{
				protected String toDisplayString(Classroom classroom)
				{
					return "" + classroom.getCapacity();
				}
			});
		
		return displays;
	}
}
