package inf43.spring2009.tpes.commands;

import inf43.spring2009.console.Console;
import inf43.spring2009.console.Prompt;
import inf43.spring2009.console.converters.TrimStringConverter;
import inf43.spring2009.console.menus.CommandFailedException;
import inf43.spring2009.console.menus.CommandHandler;
import inf43.spring2009.console.menus.CommandHandlerResult;
import inf43.spring2009.console.validators.StringIsNotEmptyValidator;
import inf43.spring2009.tpes.matchers.ClassroomByNameMatcher;
import inf43.spring2009.tpes.model.NoSuchClassroomException;
import inf43.spring2009.tpes.model.TpesData;


public class RemoveClassroomCommandHandler implements CommandHandler<TpesData>
{
	public CommandHandlerResult run(TpesData model)
	throws CommandFailedException
	{
		String name = Prompt.read(
			"Name",
			"Enter the name of the classroom to be removed",
			new TrimStringConverter(),
			new StringIsNotEmptyValidator("A classroom name must be specified"));
		
		try
		{
			model.getClassrooms().removeClassroom(
				new ClassroomByNameMatcher(name));
		}
		catch (NoSuchClassroomException e)
		{
			throw new CommandFailedException(
				"There is no classroom with that name");
		}
		
		Console.writeLine("Removed classroom: " + name);
		
		return CommandHandlerResult.ACCEPT_ANOTHER_COMMAND;
	}
}
