package inf43.spring2009.tpes.commands;

import inf43.spring2009.console.Console;
import inf43.spring2009.console.Prompt;
import inf43.spring2009.console.converters.TrimStringConverter;
import inf43.spring2009.console.menus.CommandFailedException;
import inf43.spring2009.console.menus.CommandHandler;
import inf43.spring2009.console.menus.CommandHandlerResult;
import inf43.spring2009.console.validators.StringIsNotEmptyValidator;
import inf43.spring2009.tpes.matchers.CourseByIdMatcher;
import inf43.spring2009.tpes.model.NoSuchCourseException;
import inf43.spring2009.tpes.model.TpesData;


public class RemoveCourseCommandHandler implements CommandHandler<TpesData>
{
	public CommandHandlerResult run(TpesData model)
	throws CommandFailedException
	{
		String courseId = Prompt.read(
			"ID",
			"Enter the ID of the course to be removed",
			new TrimStringConverter(),
			new StringIsNotEmptyValidator("Course ID must be specified"));

		try
		{
			model.getCourses().removeCourse(new CourseByIdMatcher(courseId));
		}
		catch (NoSuchCourseException e)
		{
			throw new CommandFailedException("There is no course with that ID");
		}
		
		Console.writeLine("Removed Course: " + courseId);
		
		return CommandHandlerResult.ACCEPT_ANOTHER_COMMAND;
	}
}
