package inf43.spring2009.tpes.commands;

import inf43.spring2009.console.Console;
import inf43.spring2009.console.Prompt;
import inf43.spring2009.console.converters.TrimStringConverter;
import inf43.spring2009.console.menus.CommandFailedException;
import inf43.spring2009.console.menus.CommandHandler;
import inf43.spring2009.console.menus.CommandHandlerResult;
import inf43.spring2009.tpes.matchers.StudentByIdMatcher;
import inf43.spring2009.tpes.model.NoSuchStudentException;
import inf43.spring2009.tpes.model.TpesData;


public class RemoveStudentCommandHandler implements CommandHandler<TpesData>
{
	public CommandHandlerResult run(TpesData model)
	throws CommandFailedException
	{
		String studentId = Prompt.read(
			"ID",
			"Enter the student ID of the student to be removed",
			new TrimStringConverter());
		
		try
		{
			model.getStudents().removeStudent(
				new StudentByIdMatcher(studentId));
		}
		catch (NoSuchStudentException e)
		{
			throw new CommandFailedException("There is no student with that ID");
		}
		
		Console.writeLine("Student removed: " + studentId);
		
		return CommandHandlerResult.ACCEPT_ANOTHER_COMMAND;
	}
}
