package inf43.spring2009.tpes.converters;

import inf43.spring2009.console.converters.Converter;
import inf43.spring2009.console.converters.ConversionException;
import inf43.spring2009.tpes.model.DayOfWeek;
import java.util.HashMap;
import java.util.Map;


public class ToDayOfWeekConverter implements Converter<DayOfWeek>
{
	private static Map<String, DayOfWeek> dayOfWeekMap;
	
	
	static
	{
		dayOfWeekMap = new HashMap<String, DayOfWeek>();
		dayOfWeekMap.put("M", DayOfWeek.MONDAY);
		dayOfWeekMap.put("MO", DayOfWeek.MONDAY);
		dayOfWeekMap.put("MON", DayOfWeek.MONDAY);
		dayOfWeekMap.put("MONDAY", DayOfWeek.MONDAY);
		dayOfWeekMap.put("TU", DayOfWeek.TUESDAY);
		dayOfWeekMap.put("TUE", DayOfWeek.TUESDAY);
		dayOfWeekMap.put("TUES", DayOfWeek.TUESDAY);
		dayOfWeekMap.put("TUESDAY", DayOfWeek.TUESDAY);
		dayOfWeekMap.put("W", DayOfWeek.WEDNESDAY);
		dayOfWeekMap.put("WE", DayOfWeek.WEDNESDAY);
		dayOfWeekMap.put("WED", DayOfWeek.WEDNESDAY);
		dayOfWeekMap.put("WEDNESDAY", DayOfWeek.WEDNESDAY);
		dayOfWeekMap.put("TH", DayOfWeek.THURSDAY);
		dayOfWeekMap.put("THU", DayOfWeek.THURSDAY);
		dayOfWeekMap.put("THUR", DayOfWeek.THURSDAY);
		dayOfWeekMap.put("THURS", DayOfWeek.THURSDAY);
		dayOfWeekMap.put("THURSDAY", DayOfWeek.THURSDAY);
		dayOfWeekMap.put("F", DayOfWeek.FRIDAY);
		dayOfWeekMap.put("FR", DayOfWeek.FRIDAY);
		dayOfWeekMap.put("FRI", DayOfWeek.FRIDAY);
		dayOfWeekMap.put("FRIDAY", DayOfWeek.FRIDAY);
		dayOfWeekMap.put("SA", DayOfWeek.SATURDAY);
		dayOfWeekMap.put("SAT", DayOfWeek.SATURDAY);
		dayOfWeekMap.put("SATURDAY", DayOfWeek.SATURDAY);
		dayOfWeekMap.put("SU", DayOfWeek.SUNDAY);
		dayOfWeekMap.put("SUN", DayOfWeek.SUNDAY);
		dayOfWeekMap.put("SUNDAY", DayOfWeek.SUNDAY);
	}
	
	
	public DayOfWeek convert(String input)
	{
		String doctoredInput = input.trim().toUpperCase();
		
		if (dayOfWeekMap.containsKey(doctoredInput))
		{
			return dayOfWeekMap.get(doctoredInput);
		}
		else
		{
			throw new ConversionException("No such day of week: " + doctoredInput);
		}
	}
}
