package inf43.spring2009.tpes.converters;

import inf43.spring2009.console.converters.ConversionException;
import inf43.spring2009.console.converters.Converter;
import inf43.spring2009.tpes.model.TimeOfDay;


public class ToTimeOfDayConverter implements Converter<TimeOfDay>
{
	public TimeOfDay convert(String input)
	{
		String[] components = input.split(":");
		
		if (components.length != 2)
		{
			conversionFailed(input);
		}
		
		try
		{
			int hour = Integer.parseInt(components[0]);
			int minute = Integer.parseInt(components[1]);

			if (hour < 0 || hour > 23 || minute < 0 || minute > 59)
			{
				conversionFailed(input);
			}
			
			return new TimeOfDay(hour, minute);
		}
		catch (NumberFormatException e)
		{
			conversionFailed(input);

			// Unreachable
			return null;
		}
	}
	
	
	private void conversionFailed(String input)
	{
		throw new ConversionException(input + " is not a valid time");
	}
}
