package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.ExitThisMenuCommandHandler;
import inf43.spring2009.tpes.commands.ListClassroomsCommandHandler;
import inf43.spring2009.tpes.commands.ListCoursesCommandHandler;
import inf43.spring2009.tpes.commands.ScheduleCourseCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;


public class CourseSchedulingMenu extends Menu<TpesData>
{
	public CourseSchedulingMenu()
	{
		super("Course Scheduling", createCommands());
	}
	
	
	private static ArrayList<Command<TpesData>> createCommands()
	{
		ArrayList<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();

		commands.add(new Command<TpesData>("CL", "List Classrooms", new ListClassroomsCommandHandler()));
		commands.add(new Command<TpesData>("CO", "List Courses", new ListCoursesCommandHandler()));
		commands.add(new Command<TpesData>("SC", "Schedule Course into Classroom", new ScheduleCourseCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit This Menu", new ExitThisMenuCommandHandler()));
		
		return commands;
	}
}
