package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.AddClassroomCommandHandler;
import inf43.spring2009.tpes.commands.ExitThisMenuCommandHandler;
import inf43.spring2009.tpes.commands.ListClassroomsCommandHandler;
import inf43.spring2009.tpes.commands.RemoveClassroomCommandHandler;
import inf43.spring2009.tpes.commands.ViewClassroomInformationCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;


public class EditClassroomsMenu extends Menu<TpesData>
{
	public EditClassroomsMenu()
	{
		super("Edit Classrooms", createCommands());
	}
	
	
	private static ArrayList<Command<TpesData>> createCommands()
	{
		ArrayList<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();
		
		commands.add(new Command<TpesData>("LI", "List Classrooms", new ListClassroomsCommandHandler()));
		commands.add(new Command<TpesData>("AD", "Add Classroom", new AddClassroomCommandHandler()));
		commands.add(new Command<TpesData>("RE", "Remove Classroom", new RemoveClassroomCommandHandler()));
		commands.add(new Command<TpesData>("VC", "View Classroom Information", new ViewClassroomInformationCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit This Menu", new ExitThisMenuCommandHandler()));
		
		return commands;
	}
}
