package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.AddCourseCommandHandler;
import inf43.spring2009.tpes.commands.ExitThisMenuCommandHandler;
import inf43.spring2009.tpes.commands.ListCoursesCommandHandler;
import inf43.spring2009.tpes.commands.RemoveCourseCommandHandler;
import inf43.spring2009.tpes.commands.ViewCourseInformationCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;


public class EditCoursesMenu extends Menu<TpesData>
{
	public EditCoursesMenu()
	{
		super("Edit Courses", createCommands());
	}


	private static ArrayList<Command<TpesData>> createCommands()
	{
		ArrayList<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();

		commands.add(new Command<TpesData>("LI", "List Courses", new ListCoursesCommandHandler()));
		commands.add(new Command<TpesData>("AD", "Add Course", new AddCourseCommandHandler()));
		commands.add(new Command<TpesData>("RE", "Remove Course", new RemoveCourseCommandHandler()));
		commands.add(new Command<TpesData>("VC", "View Course Information", new ViewCourseInformationCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit This Menu", new ExitThisMenuCommandHandler()));

		return commands;
	}
}
