package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.AddStudentCommandHandler;
import inf43.spring2009.tpes.commands.ExitThisMenuCommandHandler;
import inf43.spring2009.tpes.commands.ListStudentsCommandHandler;
import inf43.spring2009.tpes.commands.RemoveStudentCommandHandler;
import inf43.spring2009.tpes.commands.ViewStudentInformationCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;


public class EditStudentsMenu extends Menu<TpesData>
{
	public EditStudentsMenu()
	{
		super("Edit Students", createCommands());
	}
	
	
	private static ArrayList<Command<TpesData>> createCommands()
	{
		ArrayList<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();

		commands.add(new Command<TpesData>("LI", "List Students", new ListStudentsCommandHandler()));
		commands.add(new Command<TpesData>("AD", "Add Student", new AddStudentCommandHandler()));
		commands.add(new Command<TpesData>("RE", "Remove Student", new RemoveStudentCommandHandler()));
		commands.add(new Command<TpesData>("VS", "View Student Information", new ViewStudentInformationCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit This Menu", new ExitThisMenuCommandHandler()));
		
		return commands;
	}
}
