package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.ExitProgramCommandHandler;
import inf43.spring2009.tpes.commands.FinishSemesterCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;


public class MainMenu extends Menu<TpesData>
{
	public MainMenu()
	{
		super("Main Menu", createCommands());
	}
	
	
	private static ArrayList<Command<TpesData>> createCommands()
	{
		ArrayList<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();

		commands.add(new Command<TpesData>("CL", "Edit Classrooms", new EditClassroomsMenu()));
		commands.add(new Command<TpesData>("CO", "Edit Courses", new EditCoursesMenu()));
		commands.add(new Command<TpesData>("ST", "Edit Students", new EditStudentsMenu()));
		commands.add(new Command<TpesData>("CS", "Course Scheduling", new CourseSchedulingMenu()));
		commands.add(new Command<TpesData>("SE", "Student Enrollment", new StudentEnrollmentMenu()));
		commands.add(new Command<TpesData>("FS", "Finish the Current Semester", new FinishSemesterCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit", new ExitProgramCommandHandler()));
		
		return commands;
	}
}
