package inf43.spring2009.tpes.menus;

import inf43.spring2009.console.menus.Menu;
import inf43.spring2009.console.menus.Command;
import inf43.spring2009.tpes.commands.DropStudentFromCourseCommandHandler;
import inf43.spring2009.tpes.commands.EnrollStudentIntoCourseCommandHandler;
import inf43.spring2009.tpes.commands.ExitThisMenuCommandHandler;
import inf43.spring2009.tpes.commands.ListCoursesCommandHandler;
import inf43.spring2009.tpes.commands.ListStudentsCommandHandler;
import inf43.spring2009.tpes.model.TpesData;
import java.util.ArrayList;
import java.util.List;


public class StudentEnrollmentMenu extends Menu<TpesData>
{
	public StudentEnrollmentMenu()
	{
		super("Student Enrollment", createCommands());
	}
	
	
	private static List<Command<TpesData>> createCommands()
	{
		List<Command<TpesData>> commands = new ArrayList<Command<TpesData>>();
		
		commands.add(new Command<TpesData>("CO", "List Courses", new ListCoursesCommandHandler()));
		commands.add(new Command<TpesData>("ST", "List Students", new ListStudentsCommandHandler()));
		commands.add(new Command<TpesData>("ES", "Enroll Student into Course", new EnrollStudentIntoCourseCommandHandler()));
		commands.add(new Command<TpesData>("DS", "Drop Student from Course", new DropStudentFromCourseCommandHandler()));
		commands.add(new Command<TpesData>("EX", "Exit This Menu", new ExitThisMenuCommandHandler()));

		return commands;
	}
}
