package inf43.spring2009.tpes.validators;

import inf43.spring2009.console.validators.ValidatorBase;
import inf43.spring2009.tpes.matchers.ClassroomByNameMatcher;
import inf43.spring2009.tpes.model.NoSuchClassroomException;
import inf43.spring2009.tpes.model.TpesData;


public class ClassroomNameExistsValidator extends ValidatorBase<String>
{
	private TpesData model;
	
	
	public ClassroomNameExistsValidator(TpesData model, String errorMessage)
	{
		super(errorMessage);
		this.model = model;
	}
	
	
	protected boolean isValid(String result)
	{
		try
		{
			model.getClassrooms().findClassroom(new ClassroomByNameMatcher(result));
			return true;
		}
		catch (NoSuchClassroomException e)
		{
			return false;
		}
	}
}
