package inf43.spring2009.tpes.validators;

import inf43.spring2009.console.validators.ValidatorBase;
import inf43.spring2009.tpes.matchers.CourseByIdMatcher;
import inf43.spring2009.tpes.model.NoSuchCourseException;
import inf43.spring2009.tpes.model.TpesData;


public class CourseIdExistsValidator extends ValidatorBase<String>
{
	private TpesData model;
	
	
	public CourseIdExistsValidator(TpesData model, String errorMessage)
	{
		super(errorMessage);
		this.model = model;
	}
	
	
	protected boolean isValid(String result)
	{
		try
		{
			model.getCourses().findCourse(new CourseByIdMatcher(result));
			return true;
		}
		catch (NoSuchCourseException e)
		{
			return false;
		}
	}
}
