package inf43.spring2009.tpes.validators;

import inf43.spring2009.console.validators.ValidatorBase;
import inf43.spring2009.tpes.matchers.StudentByIdMatcher;
import inf43.spring2009.tpes.model.NoSuchStudentException;
import inf43.spring2009.tpes.model.TpesData;


public class StudentIdExistsValidator extends ValidatorBase<String>
{
	private TpesData model;
	
	
	public StudentIdExistsValidator(TpesData model, String errorMessage)
	{
		super(errorMessage);
		this.model = model;
	}
	
	
	protected boolean isValid(String result)
	{
		try
		{
			model.getStudents().findStudent(new StudentByIdMatcher(result));
			return true;
		}
		catch (NoSuchStudentException e)
		{
			return false;
		}
	}
}
